Loading...
Searching...
No Matches
executor.h
Go to the documentation of this file.
/*
* Copyright (C) 2023 Nuo Mi
*
* This file is part of FFmpeg.
*
* FFmpeg is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* FFmpeg is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/
#ifndef AVUTIL_EXECUTOR_H
#define AVUTIL_EXECUTOR_H
typedef struct AVExecutor AVExecutor;
typedef struct AVTask AVTask;
struct AVTask {
AVTask *next;
};
typedef struct AVTaskCallbacks {
void *user_data;
int local_context_size;
// return 1 if a's priority > b's priority
int (*priority_higher)(const AVTask *a, const AVTask *b);
// task is ready for run
int (*ready)(const AVTask *t, void *user_data);
// run the task
int (*run)(AVTask *t, void *local_context, void *user_data);
} AVTaskCallbacks;
/**
* Alloc executor
* @param callbacks callback structure for executor
* @param thread_count worker thread number, 0 for run on caller's thread directly
* @return return the executor
*/
AVExecutor* av_executor_alloc(const AVTaskCallbacks *callbacks, int thread_count);
/**
* Free executor
* @param e pointer to executor
*/
void av_executor_free(AVExecutor **e);
/**
* Add task to executor
* @param e pointer to executor
* @param t pointer to task. If NULL, it will wakeup one work thread
*/
void av_executor_execute(AVExecutor *e, AVTask *t);
#endif //AVUTIL_EXECUTOR_H
av_executor_free
void av_executor_free(AVExecutor **e)
Free executor.
av_executor_alloc
AVExecutor * av_executor_alloc(const AVTaskCallbacks *callbacks, int thread_count)
Alloc executor.
AVExecutor
struct AVExecutor AVExecutor
Definition executor.h:24
av_executor_execute
void av_executor_execute(AVExecutor *e, AVTask *t)
Add task to executor.
AVTaskCallbacks
Definition executor.h:31
AVTaskCallbacks::priority_higher
int(* priority_higher)(const AVTask *a, const AVTask *b)
Definition executor.h:37
AVTaskCallbacks::local_context_size
int local_context_size
Definition executor.h:34
AVTaskCallbacks::ready
int(* ready)(const AVTask *t, void *user_data)
Definition executor.h:40
AVTaskCallbacks::run
int(* run)(AVTask *t, void *local_context, void *user_data)
Definition executor.h:43
AVTaskCallbacks::user_data
void * user_data
Definition executor.h:32
AVTask
Definition executor.h:27
AVTask::next
AVTask * next
Definition executor.h:28